#include <stdio.h>

/* Funcao: busca
 * A funcao deve encontrar a posição (i,j) do jogador no tabuleiro.
 * O jogador é representado pelo valor -1.
 * O retorno da posicao se da pelo vetor parametro pos.
 *
 *
 * Parametros:
 *      tab: tabuleiro
 *  tabSize: largura e altura do tabuleiro (o tabuleiro é sempre quadrado)
 *      pos: posicao do jogador no tabuleiro
 *
 * Retorno:
 *   Em pos[0] deve ser setado a linha i onde esta o jogador.
 *   Em pos[1] deve ser setado a coluna j onde esta o jogador.
 */
void busca(int **tab, int tabSize, int pos[2]) {
  /* Implementar a funcao */
  return;
}

/* Funcao: visiveis
 * Retorna os monstros visiveis nas 8 posições adjacentes em ordem.
 * A posição 0 representa o canto superior esquerdo e a posição 7 o canto
 * inferior direito.
 * 0 1 2
 * 3 J 4
 * 5 6 7
 * As posições devem ter o identificador da especie do monstro presente ou zero se a
 * posição não tiver um monstro.
 *
 * Parametros:
 *      tab: tabuleiro
 *  tabSize: largura e altura do tabuleiro (o tabuleiro é sempre quadrado)
 *        v: Identificadores das posições adjacentes
 *
 * Retorno:
 *    Para cada posicao v[i], onde i=0,1,..7, deve ser setado
 *    o identificador da especie do monstro naquela posição ou 0 se a posicao
 *    estiver vazia.
 */
void visiveis(int **tab, int tabSize, int v[8]) {
  /* Implementar a funcao */
  return;
}

/* Funcao: proximos
 * Retorna quais tipos de monstros estão presentes nas 16 posições proximas ao
 * jogador mas não adjacentes a ele.
 * O valor de p[i] deve ser setado para 1 se existir ao menos uma ocorrência do monstro de
 * identificador i+1 em alguma das 16 posições proximas, ou 0 caso contrário.
 *
 * Parametros:
 *       tab: tabuleiro
 *   tabsize: tamanho do tabuleiro (sempre quadrado)
 *         p: Monstros proximos
 *  monstros: tamanho de p
 *
 * Retorno:
 *    Note que o parametro p eh um vetor de tamanho igual ao numero de especies de monstros (especies).
 *    Para cada posição i, p[i] deve ser setado com 1 se um monstro de especie (i+1) esta proximo
 *    e 0 caso contrario.
 */
void proximos(int **tab, int tabSize, int *p, int especies) {
  /* Implementar a funcao */
  return;
}

/* Funcao: movimenta
 * Movimenta o jogador, que é representado no tabuleiro pelo valor -1.
 * O jogador deve sempre permanecer dentro do tabuleiro.
 *
 * Parametros:
 *      tab: tabuleiro
 *  tabsize: tamanho do tabuleiro (sempre quadrado)
 *      desloca: contem o deslocamento que deve ser aplicado ao jogador.
 *               desloca[1] contem o deslocamento em colunas (-1, 0, ou 1)
 *               desloca[0] contem o deslocamento em linhas (-1, 0, ou 1)
 *
 * Retorno:
 *   Especie do monstro encontrado na nova posicao do jogador
 *   ou 0 se nao houver monstro nesta posicao.
 */
int movimenta(int **tab, int tabSize, int desloca[2]) {
  /* Implementar a funcao e trocar o valor de retorno */
  return 0;
}

/* Funcao: captura
 * Verifica se o jogador pode capturar o monstro de uma especie que esta na posicao do jogador.
 * Armazena o monstro capturado no vetor capturados e retorna 1 se conseguiu
 * capturar, ou 0 caso contrario.
 * Um monstro de especie 1 sempre eh capturado.
 *
 * Parametros:
 *   capturados: vetor de tamanho n_especies com a quantidade de monstros de cada especie
 *               que o jogador possui. Desta forma, capturados[i] possui a quantidade de monstros
 *               da especie (i+1) que o jogador possui.
 *   n_especies: tamanho do vetor capturados
 *   especie: numero da especie que pretende-se capturar.
 *
 * Retorno:
 *   1 se o monstro foi capturado, e 0 caso contrario.
 *   Note que o vetor capturados deve ser atualizado caso o monstro tenha sido capturado.
 */
int captura(int *capturados, int n_especies,  int especie) {
  /* Implementar a funcao e trocar o valor de retorno */
  return 0;
}
